#!/bin/sh
#------------------------------------------------------------------------------
# conntrack.cgi - show contrack table
#
# Creation:     17.10.2005  hh
# Last Update:  $Id: conntrack.cgi 11070 2006-02-23 13:26:14Z hh $
#
#------------------------------------------------------------------------------
# get main helper functions
. /srv/www/include/cgi-helper

# Functions
unique ()
{
    list=''
    for i in $*
    do
        case $list in
            *$i*) ;;
            *) list="$list $i" ;;
        esac
    done
}

get_dns_name ()
{
    set -- `nslookup $1 | grep ^Name || echo "dummy $1"`
    echo $2
}

ip_to_dnsname ()
{   # lookup unkown IPs
    for ip in $list
    do
        echo "s/>$ip</ title=\"$ip\">`get_dns_name $ip`</g" >> /tmp/sed.$$
    done
}

ip_to_wan ()
{   # replace IP of default route interface in conntrack with "WAN-IP"
    if [ -f /etc/default-route-interface ]
    then
        dev=`cat /etc/default-route-interface`
        if [ -f /var/run/$dev.ip ]
        then
            wanip=`cat /var/run/$dev.ip`
            echo "s/>$wanip</ title=\"$wanip\">WAN-IP</g" >> /tmp/sed.$$
        fi
    fi
}

ip_to_hostnames ()
{   # replace IPs of hosts in conntrack with names
    while read line
    do
        set -- $line
        case "$1" in
            "#"*) continue ;;
            *) echo "s/>$1</ title=\"$1\">$2</g" >> /tmp/sed.$$;;
        esac
    done < /etc/hosts
    case $OPT_DNSDHCP in
        yes)
            set -f
            while read line
            do
                set -- $line
                case $4 in
                    "*") ;;
                    *)
                        echo $hosts | grep -q $4
                        case $? in
                            [^0]) echo "s/>$3</ title=\"$3\">$4</g" >> /tmp/sed.$$ ;;
                        esac
                esac
            done < $DNSDHCP_LEASES_DIR/dnsmasq.leases
            set +f
        ;;
    esac
}

# Security
check_rights "status" "conntrack"

show_html_header "$_MP_contrck"
show_tab_header "$_CONT_aconn" no

case $FORM_filter in yes) fchecked="checked" ;; esac
case $FORM_dns in yes) dchecked="checked" ;; esac

cat <<EOF
<form action="$myname" method="GET">
<input type="hidden" name="sort" value="$FORM_sort">
<script type="text/javascript">
    document.write("<input onChange=\"submit()\" type=\"checkbox\" name=\"filter\" value=\"yes\" $fchecked> $_CONT_filterlocal")
</script>
<noscript>
    <input type="checkbox" name="filter" value="yes" $fchecked> $_CONT_filterlocal
    <input class="sbutton" type="submit">
</noscript>
<br>
<script type="text/javascript">
    document.write("<input onChange=\"submit()\" type=\"checkbox\" name=\"dns\" value=\"yes\" $dchecked> $_CONT_dns")
</script>
<noscript>
    <input type="checkbox" name="dns" value="yes" $dchecked> $_CONT_dns
    <input class="sbutton" type="submit">
</noscript>

</form>
EOF

case $FORM_sort in 
    src) srcimg='<img src="../img/snormal.gif">' ;;
    dst) dstimg='<img src="../img/snormal.gif">' ;;
esac

# create html table
ze="<tr><td>"
sp="<\/td><td>"
cat >/tmp/sed.$$ <<EOF
/tcp/s/^\([^ ]*\) *\(\([^ ]\+\) \)\{2,4\}src=\([^ ]*\) dst=\([^ ]*\) sport=\([^ ]*\) dport=\([^ ]*\) .*$/$ze\1$sp\4$sp\6$sp\5$sp\7$sp\2<\/td><\/tr>/
/udp/s/^\([^ ]*\) *\(\([^ ]\+\) \)\{2,4\}src=\([^ ]*\) dst=\([^ ]*\) sport=\([^ ]*\) dport=\([^ ]*\) .*$/$ze\1$sp\4$sp\6$sp\5$sp\7<\/td><\/tr>/
/icmp/s/type=8/type=echo-req/;/icmp/s/type=0/type=echo-reply/
/icmp/s/type=13/type=timestamp/;/icmp/s/type=14/type=timestamp-repl/
/icmp/s/type=15/type=info-req/;/icmp/s/type=16/type=info-reply/
/icmp/s/type=17/type=address/;/icmp/s/type=18/type=address-reply/
/icmp/s/^\([^ ]*\) *\(\([^ ]\+\) \)\{2,4\}src=\([^ ]*\) dst=\([^ ]*\) type=\([^ ]*\) .* type=\([^ ]*\) .*$/$ze\1$sp\4$sp\6$sp\5$sp\7<\/td><\/tr>/
/unknown/s/^\([^ ]*\) *\(\([^ ]\+\) \)\{2,4\}src=\([^ ]*\) dst=\([^ ]*\).*$/$ze\1$sp\4$sp$sp\5$sp<\/td><\/tr>/
EOF


case $FORM_sort in
    src|dst)
        case $FORM_sort in
            src) sstr='\3:\5' ;;
            dst) sstr='\5:\3' ;;
        esac
        scmd='sed -f /tmp/sort.$$ | sort | sed -e "s/sort=[^ ]* *//" |'
        cat >/tmp/sort.$$ <<-EOF
	s/\(.*\)\(src=\)\([0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\)\( dst=\)\([0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\)\(.*\)\(src=\)\(.*\)/sort=$sstr \1\2\3\4\5\6\7\8/
	s/sort=\([0-9]\{1,3\}\)\.\([0-9]\{1,3\}\)\.\([0-9]\{1,3\}\)\.\([0-9]\{1,3\}\):\([0-9]\{1,3\}\)\.\([0-9]\{1,3\}\)\.\([0-9]\{1,3\}\)\.\([0-9]\{1,3\}\) \(.*\)/sort=00\1.00\2.00\3.00\4:00\5.00\6.00\7.00\8 \9/
	s/sort=0\{0,2\}\([0-9]\{3\}\.\)0\{0,2\}\([0-9]\{3\}\.\)0\{0,2\}\([0-9]\{3\}\.\)0\{0,2\}\([0-9]\{3\}:\)0\{0,2\}\([0-9]\{3\}.\)0\{0,2\}\([0-9]\{3\}.\)0\{0,2\}\([0-9]\{3\}.\)0\{0,2\}\([0-9]\{3\}.\)\(.*\)/sort=\1\2\3\4\5\6\7\8\9/
EOF
    ;;
    time)
        scmd='sed "s/\([a-z]\{3,4\} *[0-9]\{1,10\} \)\([0-9]\{1,10\}\)\(.*\)/\2 \1\2\3/" | sort -n | sed "s/^[0-9]\{1,10\} //" |'
    ;;
    *) scmd= ;;
esac

case $FORM_filter in
    yes)
        fcmd="| grep -v -e \"src=127.0.0.1 dst=127.0.0.1\""

        for rip in `grep $HOSTNAME /etc/hosts | cut -d" " -f1`
        do
            # only different ip-adresses (unique)
            case $fcmd in
                *$rip*) ;;
                *) 
                    while read line
                    do
                        case $line in 
                            "#"*|"127.0.0.1"*) continue ;;
                            "# hostnames ") break ;;
                            *)
                                set -- $line
                                ip=$1
                                fcmd="$fcmd -e \"dport=$HTTPD_PORT src=$rip dst=$ip\"" 
                                fcmd="$fcmd -e \"dport=$IMOND_PORT src=$rip dst=$ip\"" 
                                fcmd="$fcmd -e \"dport=$TELMOND_PORT src=$rip dst=$ip\"" 
                            ;;
                        esac
                    done < /etc/hosts
                ;;
            esac
        done
    ;;
esac

eval 'cat /proc/net/ip_conntrack '$fcmd > /tmp/conntrack.$$

ip_to_wan
ip_to_hostnames
case $FORM_dns in
    yes)
        unique `cat /tmp/conntrack.$$ | sed "s/^\([^ ]*\) *\(\([^ ]\+\) \)\{2,4\}src=\([^ ]*\) dst=\([^ ]*\).*$/\4 \5/"`
        ip_to_dnsname
    ;;
esac

cat <<EOF
<p>$_CONT_numcon: `cat /tmp/conntrack.$$ | grep -c use`</p>
<table class="normtable">
<tr><th>$_CONT_prot</th><th colspan="2"><a href="$myname?filter=$FORM_filter&amp;sort=src">$_CONT_src$srcimg</a></th><th colspan="2"><a href="$myname?filter=$FORM_filter&amp;sort=dst">$_CONT_dest$dstimg</a></th><th>$_CONT_state</th></tr>
<tr><th>&nbsp;</th><th>$_CONT_IP</th><th>$_CONT_port</th><th>$_CONT_IP</th><th>$_CONT_port</th><th></th></tr>
EOF

eval 'cat /tmp/conntrack.'$$' | '$scmd ' sed -f /tmp/sed.'$$

rm /tmp/sort.$$ /tmp/sed.$$ /tmp/conntrack.$$ 2>/dev/null

echo '</table>'
show_tab_footer
show_html_footer
