#!/bin/sh
#--------------------------------------------------------------------
# /usr/local/bin/httpd-menu.sh - add/remove items from the httpd-menu
#
# Creation:     22.03.2002  tobig
# Last Update:  $Id: httpd-menu.sh 10915 2006-02-02 02:18:18Z hh $
#--------------------------------------------------------------------

case $1 in
    -s) silent="yes" ; shift ;;
    *)  silent="no" ;;
esac

action="$1"
link="$2"
filename=`echo $link | cut -d? -f1`
name="$3"
section="${4:-Opt}"

menufile="/etc/httpd/menu"
this="`basename $0`"
tmp="/tmp/$this.$$"
mtype="e"

if [ -f /usr/local/htdocs/$filename -a -d /srv/www ]
then
    case $silent in
        no)
            . /etc/boot.d/base-helper
            SCRIPT=httpd-menu
            log_error "Using old cgi-scripts with the new-style webgui is deprecated"
        ;;
    esac
    mtype="l"
fi

case "$action" in
  add*)

    grep "^t .* $section\$" $menufile > /dev/null 2>&1
    if [ "$?" = 1 ]
    then
      echo "t - $section" >> $menufile
    fi
    echo "d - DUMMY" >> $menufile
cat > $tmp.sed << END
/^t .* $section\$/,/^[td] / {
  /^\\([^td] \\|t .* $section\$\\)/ b
  i\\
$mtype $link $name
}
END
    sed -f $tmp.sed $menufile > $tmp.1
    grep -v "d - DUMMY" $tmp.1 > $menufile
    rm -f $tmp.*
    ;;
  rem*)
    grep -v "^$mtype $link " $menufile > $tmp.1
    cp $tmp.1 $menufile
    rm $tmp.*
    ;;
  *)
    echo "Usage: $this add <link> <name> [section]"
    echo "       $this rem <link>"
    exit 1
    ;;
esac
